#pragma section @@CODER RAM_CODE

#include "r_cg_macrodriver.h"

#include <string.h>

//#include "bsig.h"
#include "fsl.h"

/**************************************************************************
* NAME     : BootWrite
* FUNCTION : u[g̈̏
* REMARKS  : 
***************************************************************************/
int __far BootWrite( uint32_t size )
{
	fsl_write_t	wr;
	fsl_u08		blk, err;

	DI();

	/* Block0i0000h`03FFhj` Block7i1C00h`1FFFhjɏ */
	for( blk = 0; blk < 8; blk++ )
	{
		if ( FSL_BlankCheck(blk) == FSL_ERR_BLANKCHECK )
		{
			/* uNłȂΏ */
			FSL_Erase(blk);
		}

		wr.fsl_data_buffer_p_u08		= (fsl_u08 __near *)(0xFDA20 + (blk * 0x400));
		wr.fsl_destination_address_u32	= (blk * 0x400);
		wr.fsl_word_count_u08			= (fsl_u08)(0x400 / 4);

		err = FSL_Write( &wr );

		if ( err == FSL_OK )
		{
			FSL_IVerify(blk);
		}

		/* ̃ubNɏރf[^邩 */
		if ( size < ((blk + 1) * 0x400) )
		{
			break;
		}
	}

	if ( err == FSL_OK )
	{
		/* BOOT̓Av̈̃VOl`i[ubNC[X */
		if ( FSL_BlankCheck(8) == FSL_ERR_BLANKCHECK )
		{
			/* uNłȂΏ */
			FSL_Erase(8);
		}
	}

	EI();

	return 1;	/* I */
}
